package cokr.xit.fims.cmmn.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CrdnPayerHstry;
import cokr.xit.fims.cmmn.CrdnPayerHstryQuery;
import cokr.xit.fims.cmmn.dao.CrdnPayerHstryMapper;
import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;

/**단속 납부자 이력 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-16	leebj 최초 작성
 * ================================
 * </pre>
 */
@Component("crdnPayerHstryBean")
public class CrdnPayerHstryBean extends AbstractComponent {
	/** 단속 납부자 이력 정보 DAO */
	@Resource(name = "crdnPayerHstryMapper")
	private CrdnPayerHstryMapper crdnPayerHstryMapper;

	/**지정한 조건에 따라 단속 납부자 이력 목록을 조회하여 반환한다.
	 * @param req 단속 납부자 이력 조회 조건
	 * @return 단속 납부자 이력 목록
	 */
	public List<DataObject> getCrdnPayerHstryList(CrdnPayerHstryQuery req) {
		return crdnPayerHstryMapper.selectCrdnPayerHstryList(req);
	}

	/**지정한 조건에 따라 단속 납부자 이력 객체들을 반환한다.
	 * @param req 단속 납부자 이력 조회 조건
	 * @return 단속 납부자 이력 객체 목록
	 */
	public List<CrdnPayerHstry> getCrdnPayerHstrys(CrdnPayerHstryQuery req) {
		return crdnPayerHstryMapper.selectCrdnPayerHstrys(req);
	}

	/**단속 납부자 이력 정보를 등록한다.
	 * @param crdnPayerHstry 단속 납부자 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(CrdnPayerHstry crdnPayerHstry) {
		return crdnPayerHstryMapper.insert(crdnPayerHstry);
	}

	/**단속 납부자 이력 정보를 등록하고, 단속 대장의 납부자 정보를 수정한다.
	 * @param crdnPayerHstry 단속 납부자 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createHstryUpdateCrdnPyr(CrdnPayerHstry crdnPayerHstry) {
		boolean retSuccess = false;												// DB 처리 결과

		// 단속 납부자 이력 정보를 등록한다.
		retSuccess = crdnPayerHstryMapper.insert(crdnPayerHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("단속 납부자 이력 정보를 등록 중 오류가 발생하였습니다.");
		}

		// 단속 대장 납부자ID를 변경한다.
		retSuccess = crdnPayerHstryMapper.updateCrdn(crdnPayerHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("단속 납부자 이력 정보를 등록 중 오류가 발생하였습니다.");
		}

		return retSuccess;
	}
}